#ifndef _LIB_IMAGE_H_
#define _LIB_IMAGE_H_

#include <stdio.h>
#include <sys/types.h>


#define SIZEOF_PALETTE   (256 * 3)
#define MAX_IMAGES       2048

enum CM_component { CM_RED, CM_GREEN, CM_BLUE };
enum IMAGE_format { IF_RAW = 10, IF_PCX, IF_JPEG, IF_VGA };

typedef unchar image_t;
typedef unchar palette_t;


struct IMAGE_DATA
{
   short      width;
   short      height;
   image_t   *image;
   palette_t *palette;
};


#if defined (__STDC__) || defined (__cplusplus) || defined (NeedFunctionPrototypes)
#  define __PARMS(s) s
#else
#  define __PARMS(s) ()
#endif

void               image_error              __PARMS((char *mesg, int errnum, struct IMAGE_DATA **image, FILE *vga_fd));
struct IMAGE_DATA *image_alloc              __PARMS((short width, short height));
void               image_free               __PARMS((struct IMAGE_DATA **image));
struct IMAGE_DATA *image_get_part           __PARMS((struct IMAGE_DATA *image_src, short x, short y, short width, short height));
struct IMAGE_DATA *image_crop               __PARMS((struct IMAGE_DATA *image));
struct IMAGE_DATA *image_rotate             __PARMS((struct IMAGE_DATA *image, double scale, double angle, short crop_flag));
struct IMAGE_DATA *image_load_raw           __PARMS((char *filename, palette_t *palette, off_t width, off_t height, off_t image_offset, off_t palette_offset));
struct IMAGE_DATA *image_load               __PARMS((char *filename, palette_t *palette, short load_flag));
short              image_save               __PARMS((char *filename, struct IMAGE_DATA *image));
palette_t         *image_palette_load       __PARMS((char *filename));
void               image_palette_brightness __PARMS((palette_t *palette, double factor));
void               image_clean              __PARMS((void));

#undef __PARMS
#endif /* _LIB_IMAGE_H_ */
